"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RealDrawBoard = exports.RealDrawBoardTypes = exports.RealRendererTypes = void 0;
var RealRenderer_1 = require("../RealRenderer/RealRenderer");
var RealDrawBoardEvents_1 = require("./events/RealDrawBoardEvents");
var RealDrawBoardDefaults_1 = require("../../constants/defaults/RealDrawBoardDefaults");
exports.RealRendererTypes = require("../../types/RealRendererTypes");
exports.RealDrawBoardTypes = require("../../types/RealDrawBoardTypes");
__exportStar(require("../../constants/defaults/RealDrawBoardDefaults"), exports);
var boardManip_1 = require("./boardManip");
var _DOMEvents_1 = require("./_DOMEvents");
var _coords_1 = require("./_coords");
var tools_1 = require("./tools/tools");
var RealDrawBoard = /** @class */ (function (_super) {
    __extends(RealDrawBoard, _super);
    function RealDrawBoard(options) {
        var _this = 
        // *****DEFAULTS*****
        _super.call(this, options, RealDrawBoardEvents_1.RealDrawBoardEventList) || this;
        _this.tool = RealDrawBoardDefaults_1.RealDrawBoardDefaults.tool;
        /** key -> identifier, value -> coordinate
         *  For mouse, the key is 'mouse', for touches, stringified identifier -> https://developer.mozilla.org/en-US/docs/Web/API/Touch/identifier
         */
        _this._lastCoords = new Map(); /* key -> identifier, value -> coordinate*/
        _this._doPreview = true; // If a preview should be drawn
        /**
         * The preview for the current stroke
         */
        _this._previewStroke = new Map();
        _this._resetBoard = boardManip_1._resetBoard;
        _this._addDOMEvents = _DOMEvents_1._addDOMEvents;
        _this._removeDOMEvents = _DOMEvents_1._removeDOMEvents;
        _this._startStroke = tools_1.tools[RealDrawBoardDefaults_1.RealDrawBoardDefaults.tool]._startStroke;
        _this._endStroke = tools_1.tools[RealDrawBoardDefaults_1.RealDrawBoardDefaults.tool]._endStroke;
        _this._doStroke = tools_1.tools[RealDrawBoardDefaults_1.RealDrawBoardDefaults.tool]._doStroke;
        _this._toolPreview = tools_1.tools[RealDrawBoardDefaults_1.RealDrawBoardDefaults.tool]._toolPreview;
        _this._onScroll = tools_1.tools[RealDrawBoardDefaults_1.RealDrawBoardDefaults.tool]._onScroll;
        _this._getMouseCoords = _coords_1._getMouseCoords;
        _this._getTouchCoords = _coords_1._getTouchCoords;
        _this.changeToolSetting = boardManip_1.changeToolSetting;
        _this.changeTool = boardManip_1.changeTool;
        _this.clearPreview = boardManip_1.clearPreview;
        _this.clear = boardManip_1.clear;
        // --- DOM Event Listeners ---
        // --- Mouse Events ---
        _this._mouseDownEventListener = function (e) {
            if (e.button === 0 /* Left Click */) {
                if (e.ctrlKey) {
                    _this.svg.addEventListener('mousemove', _this._panEventListener);
                }
                else {
                    _this.svg.addEventListener('mousemove', _this._mouseMoveEventListener);
                    var coords = _this._getMouseCoords(e);
                    _this._startStroke(coords, 'mouse');
                    _this._lastCoords.set('mouse', coords);
                }
            }
        };
        _this._mouseUpEventListener = function (e) {
            if (e.button === 0 /* Left Click */) {
                var endCoords = _this._getMouseCoords(e);
                _this.svg.removeEventListener('mousemove', _this._mouseMoveEventListener);
                _this.svg.removeEventListener('mousemove', _this._panEventListener);
                if (_this._lastCoords.has('mouse')) {
                    _this._endStroke(endCoords, 'mouse');
                    _this._lastCoords.delete('mouse');
                }
                _this._display(_this.strokes[_this._strokeIndex]);
            }
        };
        _this._mouseLeaveEventListener = function (e) {
            _this.svg.removeEventListener('mousemove', _this._mouseMoveEventListener);
            if (_this._lastCoords.has('mouse')) {
                _this._endStroke(_this._getMouseCoords(e), 'mouse');
                _this._lastCoords.delete('mouse');
                _this._display(_this.strokes[_this._strokeIndex]);
            }
            _this.clearPreview();
        };
        _this._mouseMoveEventListener = function (e) {
            var coords = _this._getMouseCoords(e);
            _this._doStroke(coords, 'mouse');
            _this._lastCoords.set('mouse', coords);
        };
        _this._previewMouseMoveEventListener = function (e) {
            var coords = _this._getMouseCoords(e);
            if (_this._doPreview) {
                if (!_this._previewStroke.has('mouse'))
                    _this._previewStroke.set('mouse', []);
                _this._toolPreview(coords, 'mouse');
                _this._display(_this._previewStroke.get('mouse'));
            }
            _this._display(_this.strokes[_this._strokeIndex]);
        };
        _this._wheelEventListener = function (e) {
            e.preventDefault();
            if (e.ctrlKey) {
                _this.scale(Math.max(_this.scaleFactor - e.deltaY * 0.001, 1));
            }
            else
                _this._onScroll(e.deltaY * 0.05, _this._getMouseCoords(e), 'mouse');
        };
        _this._panEventListener = function (e) {
            if (e.ctrlKey) {
                _this.changeOffsets(_this._offsetX - e.movementX, _this._offsetY - e.movementY);
            }
        };
        // --- Mouse Events ---
        // --- Touch Events ---
        _this._touchStartEventListener = function (e) {
            e.preventDefault();
            for (var i = 0; i < e.touches.length; i++) {
                var coords = _this._getTouchCoords(e.touches.item(i));
                var identifier = e.touches.item(i).identifier.toString();
                _this._startStroke(coords, identifier);
                _this._lastCoords.set(identifier, coords);
            }
        };
        _this._touchEndEventListener = function (e) {
            for (var i = 0; i < e.changedTouches.length; i++) {
                var coords = _this._getTouchCoords(e.changedTouches.item(i));
                var identifier = e.changedTouches.item(i).identifier.toString();
                _this._endStroke(coords, identifier);
                _this._lastCoords.delete(identifier);
            }
            _this.clearPreview();
        };
        _this._touchMoveEventListener = function (e) {
            for (var i = 0; i < e.touches.length; i++) {
                var coords = _this._getTouchCoords(e.touches.item(i));
                _this._doStroke(coords, e.touches.item(i).identifier.toString());
                _this._lastCoords.set(e.touches.item(i).identifier.toString(), coords);
            }
        };
        _this._previewTouchMoveEventListener = function (e) {
            for (var i = 0; i < e.touches.length; i++) {
                var coords = _this._getTouchCoords(e.touches.item(i));
                var identifier = e.touches.item(i).identifier.toString();
                if (_this._doPreview) {
                    if (!_this._previewStroke.has(identifier))
                        _this._previewStroke.set(identifier, []);
                    _this._toolPreview(coords, identifier);
                    _this._display(_this._previewStroke.get(identifier));
                }
                _this._display(_this.strokes[_this._strokeIndex]);
            }
        };
        _this.settings = __assign(__assign({}, RealDrawBoardDefaults_1.RealDrawBoardDefaults), options);
        _this.toolSettings = __assign(__assign({}, tools_1.ToolDefaults), _this.settings.toolSettings);
        _this.changeTool(_this.settings.tool);
        return _this;
        // *****DEFAULTS*****
    }
    // --- Touch Events ---
    // --- DOM Event Listeners ---
    RealDrawBoard.prototype.startRender = function () {
        this._addDOMEvents();
        return this;
    };
    RealDrawBoard.prototype.stopRender = function () {
        this._removeDOMEvents();
        return this;
    };
    RealDrawBoard.prototype.reset = function () {
        this._resetBoard();
        _super.prototype.reset.call(this);
        return this;
    };
    return RealDrawBoard;
}(RealRenderer_1.RealRenderer));
exports.RealDrawBoard = RealDrawBoard;
