"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._onScroll = exports._toolPreview = exports._doStroke = exports._endStroke = exports._startStroke = exports.BrushDefaults = exports.name = void 0;
var _path_1 = require("../../RealRenderer/strokeNodes/_path");
var getRGBColorString_1 = require("../../../util/getRGBColorString");
var circle_1 = require("../../../pathMakers/circle");
var line_1 = require("../../../pathMakers/line");
var getRadiusFromThickness_1 = require("./util/getRadiusFromThickness");
exports.name = 'brush';
exports.BrushDefaults = {
    brushColor: [1, 1, 1],
    brushSize: 1
};
function _startStroke(coords, identifier) {
    this._doPreview = false;
    var brushPath = new _path_1.Path('', 'strokes');
    brushPath.setStroke(getRGBColorString_1.getRGBColorString(this.toolSettings.brushColor));
    brushPath.setStrokeWidth(this.toolSettings.brushSize);
    this._addStroke([brushPath]);
    this.strokes[this._strokeIndex].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize), this.toolSettings.brushColor, 'strokes'));
}
exports._startStroke = _startStroke;
function _endStroke(endCoords, identifier) {
    this.strokes[this._strokeIndex].push(circle_1.getCircleNode(endCoords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize), this.toolSettings.brushColor, 'strokes'));
    this._doPreview = true;
}
exports._endStroke = _endStroke;
function _doStroke(coords, identifier) {
    this.strokes[this._strokeIndex].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize), this.toolSettings.brushColor, 'strokes'));
    this.strokes[this._strokeIndex][0].appendPath(line_1.getLinePathCommand(this._lastCoords.get(identifier), coords));
}
exports._doStroke = _doStroke;
function _toolPreview(coords, identifier) {
    if (!this._previewStroke.has(identifier))
        this._previewStroke.set(identifier, []);
    if (this._previewStroke.get(identifier).length == 0) {
        var circleNode = circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize), this.toolSettings.brushColor, 'overlay');
        circleNode.setFill(getRGBColorString_1.getRGBColorString(this.toolSettings.brushColor));
        circleNode.setStroke(getRGBColorString_1.getRGBColorString(this.toolSettings.brushColor));
        this._previewStroke.get(identifier).push(circleNode);
    }
    else {
        var circleNode = this._previewStroke.get(identifier)[0];
        circleNode.updateCenter(coords);
        circleNode.updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize));
        circleNode.setFill(getRGBColorString_1.getRGBColorString(this.toolSettings.brushColor));
        circleNode.setStroke(getRGBColorString_1.getRGBColorString(this.toolSettings.brushColor));
    }
}
exports._toolPreview = _toolPreview;
function _onScroll(scrollDelta, coords, identifier) {
    this.changeToolSetting('brushSize', Math.max(1, this.toolSettings.brushSize - scrollDelta));
    if (this._previewStroke.get(identifier) && this._previewStroke.get(identifier).length !== 0) {
        this._previewStroke.get(identifier)[0].updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize));
        this._display(this._previewStroke.get(identifier));
    }
    this._toolPreview(coords, identifier);
}
exports._onScroll = _onScroll;
