"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._onScroll = exports._toolPreview = exports._doStroke = exports._endStroke = exports._startStroke = exports.EraserDefaults = exports.name = void 0;
var circle_1 = require("../../../pathMakers/circle");
var line_1 = require("../../../pathMakers/line");
var getRGBColorString_1 = require("../../../util/getRGBColorString");
var _path_1 = require("../../RealRenderer/strokeNodes/_path");
var getRadiusFromThickness_1 = require("./util/getRadiusFromThickness");
exports.name = 'eraser';
exports.EraserDefaults = {
    eraserSize: 2
};
function _startStroke(coords, identifier) {
    var brushPath = new _path_1.Path('', 'strokes');
    brushPath.setStroke(getRGBColorString_1.getRGBColorString(this.bgColor));
    brushPath.setStrokeWidth(this.toolSettings.eraserSize);
    this._addStroke([brushPath]);
    this.strokes[this._strokeIndex].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.eraserSize), this.bgColor, 'strokes'));
}
exports._startStroke = _startStroke;
function _endStroke(endCoords, identifier) {
    this.strokes[this._strokeIndex].push(circle_1.getCircleNode(endCoords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.eraserSize), this.bgColor, 'strokes'));
    this._doPreview = true;
}
exports._endStroke = _endStroke;
function _doStroke(coords, identifier) {
    this.strokes[this._strokeIndex].push(circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.eraserSize), this.bgColor, 'strokes'));
    this.strokes[this._strokeIndex][0].appendPath(line_1.getLinePathCommand(this._lastCoords.get(identifier), coords));
}
exports._doStroke = _doStroke;
function _toolPreview(coords, identifier) {
    if (this._previewStroke.get(identifier).length == 0) {
        var circleNode = circle_1.getCircleNode(coords, getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.eraserSize), this.bgColor, 'overlay');
        circleNode.setFill(getRGBColorString_1.getRGBColorString(this.bgColor));
        circleNode.setStroke(getRGBColorString_1.getRGBColorString(this.bgColor));
        circleNode.setDashed(getRGBColorString_1.getRGBColorString(this.bgColor.map(function (c) { return 1 - c; })));
        this._previewStroke.get(identifier).push(circleNode);
    }
    else {
        var circleNode = this._previewStroke.get(identifier)[0];
        circleNode.updateCenter(coords);
        circleNode.updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.eraserSize));
    }
}
exports._toolPreview = _toolPreview;
function _onScroll(scrollDelta, coords, identifier) {
    this.changeToolSetting('eraserSize', Math.max(1, this.toolSettings.eraserSize - scrollDelta));
    if (this._previewStroke.get(identifier) && this._previewStroke.get(identifier).length !== 0) {
        this._previewStroke.get(identifier)[0].updateRadius(getRadiusFromThickness_1.getRadiusFromThickness(this.toolSettings.brushSize));
        this._display(this._previewStroke.get(identifier));
    }
}
exports._onScroll = _onScroll;
