export declare class EventEmitter<Events> {
    eventHandlers: {
        [Event in keyof Events]?: Map<string, (params: Events[Event]) => void>;
    };
    constructor(eventList: (keyof Events)[]);
    on<Event extends keyof Events>(eventName: Event, handlerName: string, handler: (params: Events[Event]) => void): void;
    off<Event extends keyof Events>(eventName: Event, handlerName: string): void;
    emit<Event extends keyof Events>(eventName: Event, parameters: Events[Event]): void;
}
