"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventEmitter = void 0;
var EventEmitter = /** @class */ (function () {
    function EventEmitter(eventList) {
        var _this = this;
        this.eventHandlers = {};
        eventList.forEach(function (event) {
            _this.eventHandlers[event] = new Map();
        });
    }
    EventEmitter.prototype.on = function (eventName, handlerName, handler) {
        if (!this.eventHandlers[eventName].has(handlerName))
            this.eventHandlers[eventName].set(handlerName, handler);
    };
    EventEmitter.prototype.off = function (eventName, handlerName) {
        this.eventHandlers[eventName].delete(handlerName);
    };
    EventEmitter.prototype.emit = function (eventName, parameters) {
        this.eventHandlers[eventName].forEach(function (handler) {
            handler(parameters);
        });
    };
    return EventEmitter;
}());
exports.EventEmitter = EventEmitter;
