"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Circle = void 0;
var Circle = /** @class */ (function () {
    function Circle(center, initialRadius, section) {
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'circle');
        path.setAttribute('cx', center[0].toString());
        path.setAttribute('cy', center[1].toString());
        path.setAttribute('r', initialRadius.toString());
        this.node = path;
        this.section = section;
    }
    Circle.prototype.export = function () {
        return {
            type: 'circle',
            data: this.node.outerHTML.toString(),
            section: this.section
        };
    };
    Circle.prototype.import = function (data) {
        var wrapper = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        wrapper.innerHTML = data;
        this.node = wrapper.firstChild;
        wrapper.removeChild(this.node);
        wrapper.remove();
    };
    Circle.prototype.updateRadius = function (newRadius) {
        this.node.setAttribute('r', newRadius.toString());
    };
    Circle.prototype.updateCenter = function (newCenter) {
        this.node.setAttribute('cx', newCenter[0].toString());
        this.node.setAttribute('cy', newCenter[1].toString());
    };
    Circle.prototype.setStroke = function (stroke) {
        this.node.setAttribute('stroke', stroke);
    };
    Circle.prototype.setFill = function (fill) {
        this.node.setAttribute('fill', fill);
    };
    Circle.prototype.setStrokeWidth = function (width) {
        this.node.setAttribute('stroke-width', width.toString());
    };
    Circle.prototype.setDashed = function (dashColor) {
        this.node.setAttribute('stroke-dasharray', '2,2');
        this.setStroke(dashColor);
    };
    Circle.prototype.delete = function () {
        this.node.remove();
    };
    return Circle;
}());
exports.Circle = Circle;
