"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Path = void 0;
var Path = /** @class */ (function () {
    function Path(initialD, section) {
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'path');
        path.setAttribute('d', initialD);
        this.node = path;
        this.section = section;
    }
    Path.prototype.export = function () {
        return {
            type: 'path',
            data: this.node.outerHTML.toString(),
            section: this.section
        };
    };
    Path.prototype.import = function (data) {
        var wrapper = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        wrapper.innerHTML = data;
        this.node = wrapper.firstChild;
        wrapper.removeChild(this.node);
        wrapper.remove();
    };
    Path.prototype.updatePath = function (newD) {
        this.node.setAttribute('d', newD);
    };
    Path.prototype.appendPath = function (appendD) {
        this.node.setAttribute('d', this.node.getAttribute('d') + ' ' + appendD);
    };
    Path.prototype.setStroke = function (stroke) {
        this.node.setAttribute('stroke', stroke);
    };
    Path.prototype.setFill = function (fill) {
        this.node.setAttribute('fill', fill);
    };
    Path.prototype.setStrokeWidth = function (width) {
        this.node.setAttribute('stroke-width', width.toString());
    };
    Path.prototype.delete = function () {
        this.node.remove();
    };
    return Path;
}());
exports.Path = Path;
