"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Polygon = void 0;
var Polygon = /** @class */ (function () {
    function Polygon(points, section) {
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'polygon');
        var pointsString = '';
        points.forEach(function (point) {
            pointsString += point[0] + "," + point[1] + " ";
        });
        path.setAttribute('points', pointsString);
        this.node = path;
        this.section = section;
    }
    Polygon.prototype.export = function () {
        return {
            type: 'polygon',
            data: this.node.outerHTML.toString(),
            section: this.section
        };
    };
    Polygon.prototype.import = function (data) {
        var wrapper = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        wrapper.innerHTML = data;
        this.node = wrapper.firstChild;
        wrapper.removeChild(this.node);
        wrapper.remove();
    };
    Polygon.prototype.updatePoints = function (newPoints) {
        var pointsString = '';
        newPoints.forEach(function (point) {
            pointsString += point[0] + "," + point[1] + " ";
        });
        this.node.setAttribute('points', pointsString);
    };
    Polygon.prototype.addPoint = function (point) {
        this.node.setAttribute('points', this.node.getAttribute('points') + (point[0] + "," + point[1] + " "));
    };
    Polygon.prototype.setStroke = function (stroke) {
        this.node.setAttribute('stroke', stroke);
    };
    Polygon.prototype.setFill = function (fill) {
        this.node.setAttribute('fill', fill);
    };
    Polygon.prototype.setStrokeWidth = function (width) {
        this.node.setAttribute('stroke-width', width.toString());
    };
    Polygon.prototype.delete = function () {
        this.node.remove();
    };
    return Polygon;
}());
exports.Polygon = Polygon;
