"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Text = void 0;
var Text = /** @class */ (function () {
    function Text(position, initialText, section) {
        var path = document.createElementNS('http://www.w3.org/2000/svg', 'text');
        path.textContent = initialText;
        path.setAttribute('x', position[0].toString());
        path.setAttribute('y', position[1].toString());
        this.node = path;
        this.section = section;
    }
    Text.prototype.export = function () {
        return {
            type: 'text',
            data: this.node.outerHTML.toString(),
            section: this.section
        };
    };
    Text.prototype.import = function (data) {
        var wrapper = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        wrapper.innerHTML = data;
        this.node = wrapper.firstChild;
        wrapper.removeChild(this.node);
        wrapper.remove();
    };
    Text.prototype.updateText = function (newText) {
        this.node.textContent = newText;
    };
    Text.prototype.setStyle = function (proprty, value) {
        this.node.style[proprty] = value;
    };
    Text.prototype.delete = function () {
        this.node.remove();
    };
    return Text;
}());
exports.Text = Text;
