"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.redo = exports.undo = void 0;
var clamp_1 = require("../../util/clamp");
function undo(numUndo) {
    if (numUndo === void 0) { numUndo = 1; }
    this._strokeIndex = clamp_1.clamp(this._strokeIndex - numUndo, 0, this.strokes.length - 1);
    for (var i = this._strokeIndex + 1; i < this.strokes.length; i++) {
        this.strokes[i].forEach(function (strokeNode) { return strokeNode.delete(); });
    }
    return this;
}
exports.undo = undo;
function redo(numRedo) {
    if (numRedo === void 0) { numRedo = 1; }
    var doRedo = clamp_1.clamp(numRedo, numRedo, this.strokes.length - this._strokeIndex - 1);
    for (var i = 0; i < doRedo; i++) {
        this._strokeIndex++;
        this._display(this.strokes[this._strokeIndex]);
    }
    return this;
}
exports.redo = redo;
