import { Path } from '../renderers/RealRenderer/strokeNodes/_path';
import { Text } from '../renderers/RealRenderer/strokeNodes/_text';
import { Circle } from '../renderers/RealRenderer/strokeNodes/_circle';
import { Polygon } from '../renderers/RealRenderer/strokeNodes/_polygon';
export declare type GraphDimensions = [number, number];
export declare type Color = [number, number, number];
export declare type Coordinate = [number, number];
export declare type StrokeNode = Path | Circle | Text | Polygon;
export declare type SVGSection = 'bg' | 'strokes' | 'overlay';
export declare type SVGSections = {
    [Property in SVGSection]: SVGGElement;
};
/**
 * One stroke is an combination of multiple stroke nodes
 */
export declare type Stroke = StrokeNode[];
export declare type StrokeNodeData = {
    type: 'path' | 'circle' | 'text' | 'polygon';
    data: string;
    section: SVGSection;
};
export declare type StrokeExport = StrokeNodeData[];
export declare type RealExport = {
    exportData: StrokeExport[];
    strokeIndex: number;
    dimensions: GraphDimensions;
};
export declare type BGAxes = {
    type: 'axes';
    axesColor: Color;
    xOffset: number;
    yOffset: number;
};
export declare type BGRuled = {
    type: 'ruled';
    orientation: 'vertical' | 'horizontal';
    spacing: number;
    lineColor: Color;
};
export declare type BGGrid = {
    type: 'grid';
    xSpacing: number;
    ySpacing: number;
    lineColor: Color;
};
export declare type BGNone = {
    type: 'none';
};
export declare type BGType = BGNone | BGRuled | BGGrid | BGAxes;
export interface IRealRendererOptionals {
    dimensions: GraphDimensions;
    bgColor: Color;
    bgType: BGType;
    drawsPerFrame: number;
    timeStep: number;
    initTime: number;
    scaleFactor: number;
}
export interface IRealRendererNonOptionals {
    svg: SVGSVGElement;
}
export declare type RealRendererSettings = IRealRendererNonOptionals & IRealRendererOptionals;
export declare type RealRendererOptions = IRealRendererNonOptionals & (IRealRendererOptionals | {});
